package ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav;

import java.net.URL;
import java.util.List;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.xml.namespace.QName;
import javax.xml.transform.Source;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.Dispatch;
import javax.xml.ws.Holder;
import javax.xml.ws.Service;
import javax.xml.ws.soap.SOAPBinding;

public class Item_PortProxy {

	protected Descriptor _descriptor;

	public class Descriptor {
		private ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.ItemService _service = null;
		private ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.ItemPort _proxy = null;
		private Dispatch<Source> _dispatch = null;
		private boolean _useJNDIOnly = false;

		public Descriptor() {
			init();
		}

		public Descriptor(final URL wsdlLocation, final QName serviceName) {
			_service = new ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.ItemService(wsdlLocation, serviceName);
			initCommon();
		}

		public void init() {
			_service = null;
			_proxy = null;
			_dispatch = null;
			try {
				final InitialContext ctx = new InitialContext();
				_service = (ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.ItemService) ctx.lookup("java:comp/env/service/Item_Service");
			} catch (final NamingException e) {
				if ("true".equalsIgnoreCase(System.getProperty("DEBUG_PROXY"))) {
					System.out.println("JNDI lookup failure: javax.naming.NamingException: " + e.getMessage());
					e.printStackTrace(System.out);
				}
			}

			if (_service == null && !_useJNDIOnly) {
				_service = new ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.ItemService();
			}
			initCommon();
		}

		private void initCommon() {
			_proxy = _service.getItemPort();
		}

		public ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.ItemPort getProxy() {
			return _proxy;
		}

		public void useJNDIOnly(final boolean useJNDIOnly) {
			_useJNDIOnly = useJNDIOnly;
			init();
		}

		public Dispatch<Source> getDispatch() {
			if (_dispatch == null) {
				final QName portQName = new QName("urn:microsoft-dynamics-schemas/page/item", "Item_Port");
				_dispatch = _service.createDispatch(portQName, Source.class, Service.Mode.MESSAGE);

				final String proxyEndpointUrl = getEndpoint();
				final BindingProvider bp = _dispatch;
				final String dispatchEndpointUrl = (String) bp.getRequestContext().get(BindingProvider.ENDPOINT_ADDRESS_PROPERTY);
				if (!dispatchEndpointUrl.equals(proxyEndpointUrl)) {
					bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, proxyEndpointUrl);
				}
			}
			return _dispatch;
		}

		public String getEndpoint() {
			final BindingProvider bp = (BindingProvider) _proxy;
			return (String) bp.getRequestContext().get(BindingProvider.ENDPOINT_ADDRESS_PROPERTY);
		}

		public void setEndpoint(final String endpointUrl) {
			BindingProvider bp = (BindingProvider) _proxy;
			bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, endpointUrl);

			if (_dispatch != null) {
				bp = _dispatch;
				bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, endpointUrl);
			}
		}

		public void setMTOMEnabled(final boolean enable) {
			final SOAPBinding binding = (SOAPBinding) ((BindingProvider) _proxy).getBinding();
			binding.setMTOMEnabled(enable);
		}
	}

	public Item_PortProxy() {
		_descriptor = new Descriptor();
		_descriptor.setMTOMEnabled(false);
	}

	public Item_PortProxy(final URL wsdlLocation, final QName serviceName) {
		_descriptor = new Descriptor(wsdlLocation, serviceName);
		_descriptor.setMTOMEnabled(false);
	}

	public Descriptor _getDescriptor() {
		return _descriptor;
	}

	public Item read(final String no) {
		return _getDescriptor().getProxy().read(no);
	}

	public ItemList readMultiple(final List<ItemFilter> filter, final String bookmarkKey, final int setSize) {
		return _getDescriptor().getProxy().readMultiple(filter, bookmarkKey, setSize);
	}

	public boolean isUpdated(final String key) {
		return _getDescriptor().getProxy().isUpdated(key);
	}

	public void create(final Holder<Item> item) {
		_getDescriptor().getProxy().create(item);
	}

	public void createMultiple(final Holder<ItemList> itemList) {
		_getDescriptor().getProxy().createMultiple(itemList);
	}

	public void update(final Holder<Item> item) {
		_getDescriptor().getProxy().update(item);
	}

	public void updateMultiple(final Holder<ItemList> itemList) {
		_getDescriptor().getProxy().updateMultiple(itemList);
	}

	public boolean delete(final String key) {
		return _getDescriptor().getProxy().delete(key);
	}

}