package ch.hslu.edu.enapp.webshop.boundary;

import java.util.ArrayList;
import java.util.List;

import ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.Item;
import ch.hslu.edu.enapp.webshop.boundary.webservices.msdynnav.ItemList;
import ch.hslu.edu.enapp.webshop.common.dto.ProductDTO;
import ch.hslu.edu.enapp.webshop.entity.Product;

public class ProductConverter {

	public static ProductDTO createDTOFromItem(final Item item) {
		final ProductDTO productDTOReturn = new ProductDTO();
		productDTOReturn.setId(item.getNo());
		productDTOReturn.setDescription(item.getNo());
		productDTOReturn.setMediapath(item.getMediafileName());
		productDTOReturn.setName(item.getDescription());
		productDTOReturn.setUnitprice(item.getUnitPrice());
		productDTOReturn.setMsDynNAVItemNo(item.getNo());
		return productDTOReturn;
	}

	public static List<ProductDTO> createDTOListFromItemList(final ItemList itemList) {
		final List<ProductDTO> productDTOListReturn = new ArrayList<ProductDTO>();

		for (final Item item : itemList.getItem()) {
			final ProductDTO productTemp = createDTOFromItem(item);
			productDTOListReturn.add(productTemp);
		}
		return productDTOListReturn;
	}

	public static Product createEntityFromDTO(final ProductDTO productDTO) {
		final Product productReturn = new Product();
		// productReturn.setId(productDTO.getId());
		productReturn.setMsDynNAVItemNo(productDTO.getMsDynNAVItemNo());
		productReturn.setDescription(productDTO.getDescription());
		productReturn.setMediapath(productDTO.getMediapath());
		productReturn.setName(productDTO.getName());
		productReturn.setUnitprice(productDTO.getUnitprice());

		return productReturn;
	}

}
