package ch.hslu.edu.enapp.webshop.control;

import java.math.BigDecimal;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;

import ch.hslu.edu.enapp.webshop.entity.Purchaseitem;

import com.ibm.jpa.web.Action;
import com.ibm.jpa.web.JPAManager;
import com.ibm.jpa.web.NamedQueryTarget;

@SuppressWarnings("unchecked")
@JPAManager(targetEntity = ch.hslu.edu.enapp.webshop.entity.Purchaseitem.class)
public class PurchaseitemManager {

	@PersistenceUnit
	private EntityManagerFactory emf;

	public PurchaseitemManager() {

	}

	private EntityManager getEntityManager() {
		return emf.createEntityManager();
	}

	@Action(Action.ACTION_TYPE.CREATE)
	public void createPurchaseitem(final Purchaseitem purchaseitem) throws Exception {
		final EntityManager em = getEntityManager();
		try {
			em.persist(purchaseitem);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.DELETE)
	public void deletePurchaseitem(Purchaseitem purchaseitem) throws Exception {
		final EntityManager em = getEntityManager();
		try {
			purchaseitem = em.merge(purchaseitem);
			em.remove(purchaseitem);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.UPDATE)
	public void updatePurchaseitem(Purchaseitem purchaseitem) throws Exception {
		final EntityManager em = getEntityManager();
		try {
			purchaseitem = em.merge(purchaseitem);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.FIND)
	public Purchaseitem findPurchaseitemById(final int id) {
		Purchaseitem purchaseitem = null;
		final EntityManager em = getEntityManager();
		try {
			purchaseitem = em.find(Purchaseitem.class, id);
		} finally {
			em.close();
		}
		return purchaseitem;
	}

	@Action(Action.ACTION_TYPE.NEW)
	public Purchaseitem getNewPurchaseitem() {

		final Purchaseitem purchaseitem = new Purchaseitem();

		return purchaseitem;
	}

	@NamedQueryTarget("getPurchaseitemByUnitprice")
	public List<Purchaseitem> getPurchaseitemByUnitprice(final BigDecimal unitprice) {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitemByUnitprice");
			query.setParameter("unitprice", unitprice);
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getPurchaseitemByQuantity")
	public List<Purchaseitem> getPurchaseitemByQuantity(final BigDecimal quantity) {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitemByQuantity");
			query.setParameter("quantity", quantity);
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getPurchaseitemByPurchaseid")
	public List<Purchaseitem> getPurchaseitemByPurchaseid(final int purchaseid) {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitemByPurchaseid");
			query.setParameter("purchaseid", purchaseid);
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getPurchaseitemByProductid")
	public List<Purchaseitem> getPurchaseitemByProductid(final String productid) {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitemByProductid");
			query.setParameter("productid", productid);
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getPurchaseitemByLineamount")
	public List<Purchaseitem> getPurchaseitemByLineamount(final BigDecimal lineamount) {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitemByLineamount");
			query.setParameter("lineamount", lineamount);
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getPurchaseitemByDescription")
	public List<Purchaseitem> getPurchaseitemByDescription(final String description) {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitemByDescription");
			query.setParameter("description", description);
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getPurchaseitemById")
	public List<Purchaseitem> getPurchaseitemById(final int id) {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitemById");
			query.setParameter("id", id);
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getPurchaseitem")
	public List<Purchaseitem> getPurchaseitem() {
		final EntityManager em = getEntityManager();
		List<Purchaseitem> results = null;
		try {
			final Query query = em.createNamedQuery("getPurchaseitem");
			results = query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

}