package ch.hslu.edu.enapp.webshop.control;

import com.ibm.jpa.web.JPAManager;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import com.ibm.jpa.web.NamedQueryTarget;
import com.ibm.jpa.web.Action;
import javax.persistence.PersistenceUnit;
import ch.hslu.edu.enapp.webshop.entity.UserGroup;
import ch.hslu.edu.enapp.webshop.entity.UserGroupPK;
import java.util.List;
import javax.persistence.Query;

@SuppressWarnings("unchecked")
@JPAManager(targetEntity = ch.hslu.edu.enapp.webshop.entity.UserGroup.class)
public class UserGroupManager {

	@PersistenceUnit
	private EntityManagerFactory emf;

	public UserGroupManager() {
	
	}

	private EntityManager getEntityManager() {
		return emf.createEntityManager();
	}

	@Action(Action.ACTION_TYPE.CREATE)
	public void createUserGroup(UserGroup userGroup) throws Exception {
		EntityManager em = getEntityManager();
		try {
			em.persist(userGroup);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.DELETE)
	public void deleteUserGroup(UserGroup userGroup) throws Exception {
		EntityManager em = getEntityManager();
		try {
			userGroup = em.merge(userGroup);
			em.remove(userGroup);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.UPDATE)
	public void updateUserGroup(UserGroup userGroup) throws Exception {
		EntityManager em = getEntityManager();
		try {
			userGroup = em.merge(userGroup);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.FIND)
	public UserGroup findUserGroupByPrimaryKey(int iduser, String idgroup) {
		UserGroup userGroup = null;
		EntityManager em = getEntityManager();
		UserGroupPK pk = new UserGroupPK();
		pk.setIduser(iduser);
		pk.setIdgroup(idgroup);
		try {
			userGroup = (UserGroup) em.find(UserGroup.class, pk);
		} finally {
			em.close();
		}
		return userGroup;
	}

	@Action(Action.ACTION_TYPE.NEW)
	public UserGroup getNewUserGroup() {
	
		UserGroup userGroup = new UserGroup();
	
		UserGroupPK id = new UserGroupPK();
		userGroup.setId(id);
	
		return userGroup;
	}

	@NamedQueryTarget("getUserGroupById_idgroup")
	public List<UserGroup> getUserGroupById_idgroup(String id_idgroup) {
		EntityManager em = getEntityManager();
		List<UserGroup> results = null;
		try {
			Query query = em.createNamedQuery("getUserGroupById_idgroup");
			query.setParameter("id_idgroup", id_idgroup);
			results = (List<UserGroup>) query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getUserGroupById_iduser")
	public List<UserGroup> getUserGroupById_iduser(int id_iduser) {
		EntityManager em = getEntityManager();
		List<UserGroup> results = null;
		try {
			Query query = em.createNamedQuery("getUserGroupById_iduser");
			query.setParameter("id_iduser", id_iduser);
			results = (List<UserGroup>) query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getUserGroup")
	public List<UserGroup> getUserGroup() {
		EntityManager em = getEntityManager();
		List<UserGroup> results = null;
		try {
			Query query = em.createNamedQuery("getUserGroup");
			results = (List<UserGroup>) query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

}