package ch.hslu.edu.enapp.webshop.entity;

import java.io.Serializable;
import javax.persistence.*;


/**
 * The persistent class for the customer database table.
 * 
 */
@Entity
@Table(name="customer")
@NamedQueries({ 
	@NamedQuery(name = "getCustomerByNAVCustomer", query = "SELECT c FROM Customer c WHERE c.NAVCustomer = :NAVCustomer"), 
	@NamedQuery(name = "getCustomerByUsername", query = "SELECT c FROM Customer c WHERE c.username = :username"),
	@NamedQuery(name = "getCustomerByPassword", query = "SELECT c FROM Customer c WHERE c.password = :password"),
	@NamedQuery(name = "getCustomerByName", query = "SELECT c FROM Customer c WHERE c.name = :name"),
	@NamedQuery(name = "getCustomerByEmail", query = "SELECT c FROM Customer c WHERE c.email = :email"),
	@NamedQuery(name = "getCustomerByAddress", query = "SELECT c FROM Customer c WHERE c.address = :address"),
	@NamedQuery(name = "getCustomerById", query = "SELECT c FROM Customer c WHERE c.id = :id"),
	@NamedQuery(name = "getCustomer", query = "SELECT c FROM Customer c") 
})
public class Customer implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private int id;

	private String address;

	private String email;

	private String name;

	private String NAVCustomer;

	private String password;

	private String username;

	public Customer() {
	}

	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getAddress() {
		return this.address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getNAVCustomer() {
		return this.NAVCustomer;
	}

	public void setNAVCustomer(String NAVCustomer) {
		this.NAVCustomer = NAVCustomer;
	}

	public String getPassword() {
		return this.password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getUsername() {
		return this.username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

}