package ch.hslu.edu.enapp.webshop.entity;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 * The persistent class for the product database table.
 * 
 */
@Entity
@Table(name = "product")
@NamedQueries({ @NamedQuery(name = "getProductByUnitprice", query = "SELECT p FROM Product p WHERE p.unitprice = :unitprice"),
		@NamedQuery(name = "getProductByName", query = "SELECT p FROM Product p WHERE p.name = :name"),
		@NamedQuery(name = "getProductByMediapath", query = "SELECT p FROM Product p WHERE p.mediapath = :mediapath"),
		@NamedQuery(name = "getProductByDescription", query = "SELECT p FROM Product p WHERE p.description = :description"),
		@NamedQuery(name = "getProductById", query = "SELECT p FROM Product p WHERE p.id = :id"),
		@NamedQuery(name = "getProduct", query = "SELECT p FROM Product p") })
public class Product implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;

	private String msDynNAVItemNo;
	private String description;

	private String mediapath;

	private String name;

	private BigDecimal unitprice;

	public Product() {
	}

	public int getId() {
		return this.id;
	}

	public void setId(final int id) {
		this.id = id;
	}

	public String getMsDynNAVItemNo() {
		return this.msDynNAVItemNo;
	}

	public void setMsDynNAVItemNo(final String msDynNAVItemNo) {
		this.msDynNAVItemNo = msDynNAVItemNo;
	}

	public String getDescription() {
		return this.description;
	}

	public void setDescription(final String description) {
		this.description = description;
	}

	public String getMediapath() {
		return this.mediapath;
	}

	public void setMediapath(final String mediapath) {
		this.mediapath = mediapath;
	}

	public String getName() {
		return this.name;
	}

	public void setName(final String name) {
		this.name = name;
	}

	public BigDecimal getUnitprice() {
		return this.unitprice;
	}

	public void setUnitprice(final BigDecimal unitprice) {
		this.unitprice = unitprice;
	}

}