package ch.hslu.edu.enapp.webshop.jsf;

import java.io.Serializable;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

import ch.hslu.edu.enapp.webshop.common.CustomerServiceRemote;
import ch.hslu.edu.enapp.webshop.common.dto.CustomerDTO;

@Named
@SessionScoped
public class Customer implements Serializable {
	private static final long serialVersionUID = 1L;

	// private CustomerDTO customer;
	private String username;
	private String name;
	private String address;
	private String email;
	private String pwd1;
	private String pwd2;
	private boolean updateSuccess = false;
	private String updateStatus;

	@EJB
	private CustomerServiceRemote customerService;

	@PostConstruct
	public void init() {
		// empty
	}

	public void setUsername(final String username) {
		this.username = username;
	}

	public void setName(final String newName) {
		this.name = newName;
	}

	public void setAddress(final String newAddress) {
		this.address = newAddress;
	}

	public void setEmail(final String newEmail) {
		this.email = newEmail;
	}

	public void setPwd1(final String newPwd1) {
		this.pwd1 = newPwd1;
	}

	public void setPwd2(final String newPwd2) {
		this.pwd2 = newPwd2;
	}

	public String getPwd1() {
		return "";
	}

	public String getPwd2() {
		return "";
	}

	public String createCustomer() {
		if (pwd1 == null) {
			pwd1 = "";
		}
		if (pwd2 == null) {
			pwd2 = "";
		}

		System.out.println("Create Customer:");
		System.out.println("  Account: " + this.username);
		System.out.println("     Name: " + this.name);
		System.out.println("  Address: " + this.address);
		System.out.println("    EMail: " + this.email);
		System.out.println("    PWD 1: " + this.pwd1);
		System.out.println("    PWD 2: " + this.pwd2);

		updateSuccess = false;
		updateStatus = "";

		if (username.isEmpty() || name.isEmpty() || address.isEmpty() || email.isEmpty() || pwd1.isEmpty() || pwd2.isEmpty()) {
			updateSuccess = false;
			updateStatus = "Please fill out all fields!";
			return "/register.xhtml?create=done&faces-redirect=true";
		}

		if (pwd1.length() > 2) {
			if (pwd1.equals(pwd2)) {
				if (customerService.getCustomerByUsername(this.username).getId() > 0) {
					updateStatus = "Please choose another Username!";
				} else {
					updateSuccess = true;
				}
			} else {
				updateStatus = "Please confirm the new Password.";
			}
		} else {
			updateStatus = "New password must contain at least 3 chars!";
		}

		if (!updateSuccess) {
			return "/register.xhtml?create=done&faces-redirect=true";
		}

		// persist new User
		final CustomerDTO customer = new CustomerDTO();
		customer.setUsername(username);
		customer.setName(name);
		customer.setAddress(address);
		customer.setEmail(email);
		customer.setPassword(pwd1);

		updateSuccess = customerService.createCustomerWithLogin(customer);

		if (updateSuccess) {
			// success
			updateStatus = "Customer successfully created!";
		} else {
			// error
			updateStatus = "Create Customer failed...";
		}

		return "/register.xhtml?create=done&faces-redirect=true";
	}

	public boolean isUpdateSuccess() {
		return updateSuccess;
	}

	public String getUpdateStatus() {
		return updateStatus;
	}

	public String getUsername() {
		return this.username;
	}

	public String getName() {
		return this.name;
	}

	public String getAddress() {
		return this.address;
	}

	public String getEmail() {
		return this.email;
	}

}
