package ch.hslu.edu.enapp.webshop.admin.jsf;

import java.io.Serializable;

import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

import ch.hslu.edu.enapp.webshop.common.CustomerServiceRemote;
import ch.hslu.edu.enapp.webshop.common.dto.CustomerDTO;

@Named
@SessionScoped
public class NavAccount implements Serializable {
	private static final long serialVersionUID = 1L;

	// private CustomerDTO customer;
	private CustomerDTO customerDTO;
	private String navCustomer;
	private String username;
	private String name;

	@EJB
	private CustomerServiceRemote customerService;

	public String getUsernameAndLoadData(final int customerId) {
		this.customerDTO = customerService.getCustomerById(customerId);
		this.navCustomer = customerDTO.getNAVCustomer();
		this.username = customerDTO.getUsername();
		this.name = customerDTO.getName();
		return this.username;
	}

	public String getName() {
		return this.name;
	}

	public String getNavCustomer() {
		return this.navCustomer;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(final String username) {
		this.username = username;
	}

	public void setName(final String name) {
		this.name = name;
	}

	public void setNavCustomer(final String navCustomer) {
		this.navCustomer = navCustomer;
	}

	public String updateNav() {
		customerDTO.setNAVCustomer(this.navCustomer);
		customerService.updateCustomer(customerDTO);

		return "/secured/accounts.xhtml?update=done&faces-redirect=true";
	}

}
